000010 IDENTIFICATION DIVISION.
000020 PROGRAM-ID. TESTREG.
000030 DATE-COMPILED.
000040* ------------------------: Program to demonstrate maintaining
000050* 			: .INI files with GUI ScreenIO.
000060*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000070 ENVIRONMENT DIVISION.
000080*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000090 CONFIGURATION SECTION.
000100 SOURCE-COMPUTER. IBM-PC.
000110 OBJECT-COMPUTER. IBM-PC.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 DATA DIVISION.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 WORKING-STORAGE SECTION.
000160 01  V--VERSION-LEVEL		    PIC 9(3) VALUE 14.
000170*
000180* ------------------------: Copy the .ini file API copybooks.
000190*
000200	       COPY WIN32API.
000210	       COPY INIFILE.
000220*
000230* ------------------------: Copy the panels.
000240*
000250	       COPY AINIMAIN.
000260	       COPY AINIPAN.
000270*
000280*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000290 PROCEDURE DIVISION.
000300*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000310*
000320	   PERFORM 0101-DISPLAY-CONTAINER.
000330*
000340* ------------------------: Display the test panel.
000350*
000360	   PERFORM WITH TEST AFTER
000370		 UNTIL AINIPAN-EVENT-CLOSE-WINDOW
000380		 OR AINIPAN-EVENT-CLOSE-AND-STOP
000390		 OR AINIPAN-MENU-EXIT
000400*
000410	     CALL 'GS' USING AINIPAN-1
000420			     AINIPAN-2
000430			     AINIPAN-3
000440			     AINIPAN-4
000450* ------------------------: Load the filename from the panel.
000460*
000470	     MOVE P-INI-FILE-FILENAME TO INI-FILE-FILENAME
000480*
000490* ------------------------: Load the subkey value from the panel.
000500* 			: This is the [Section] name...
000510*
000520	     MOVE P-INI-FILE-SUBKEY TO INI-FILE-SUBKEY
000530*
000540	     EVALUATE TRUE
000550*
000560	       WHEN AINIPAN-SAVE
000570		 PERFORM 0102-INI-FILE-SAVE
000580*
000590	       WHEN AINIPAN-RETRIEVE
000600		 PERFORM 0103-INI-FILE-GET
000610*
000620	       WHEN AINIPAN-DELETE-VALUE
000630		 PERFORM 0104-INI-FILE-DELETE-VALUE
000640*
000650	       WHEN AINIPAN-DELETE-SECTION
000660		 PERFORM 0105-INI-FILE-DELETE-SECTION
000670*
000680	       WHEN OTHER
000690		 CONTINUE
000700*
000710	     END-EVALUATE
000720*
000730	   END-PERFORM.
000740*
000750* ------------------------: Close the container.
000760*
000770	   SET AINIMAIN-DO-CLOSE TO TRUE.
000780	   PERFORM 0101-DISPLAY-CONTAINER.
000790*
000800	   STOP RUN.
000810*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000820 0100-GS-UTILITY SECTION.
000830* -====-
000840 0101-DISPLAY-CONTAINER.
000850* 			:---------------------------------------
000860* ------------------------: Open the application window (the
000870* 			: container for this application)
000880* 			:---------------------------------------
000890*
000900	   CALL 'GS' USING AINIMAIN-1
000910			   AINIMAIN-2
000920			   AINIMAIN-3
000930			   AINIMAIN-4.
000940* -====-
000950 0102-INI-FILE-SAVE.
000960* ------------------------: Load the value name and associated
000970* 			: data to be placed in the file.
000980*
000990	   MOVE P-VALUENAME TO INI-FILE-VALUENAME.
001000	   MOVE P-DATA TO INI-FILE-DATA.
001010*
001020* ------------------------: Call the API to update the file.
001030*
001040	   SET API-WRITEPRIVATEPROFILESTRING TO TRUE.
001050	   PERFORM 0106-CALL-WINAPI.
001060* -====-
001070 0103-INI-FILE-GET.
001080* ------------------------: Load the value name to be retrieved.
001090*
001100	   MOVE P-VALUENAME TO INI-FILE-VALUENAME.
001110*
001120* ------------------------: Call the API to read the file.
001130*
001140	   SET API-GETPRIVATEPROFILESTRING TO TRUE.
001150	   PERFORM 0106-CALL-WINAPI.
001160*
001170* ------------------------: Update panel with the data we got.
001180*
001190	   MOVE INI-FILE-DATA TO P-DATA.
001200* -====-
001210 0104-INI-FILE-DELETE-VALUE.
001220* ------------------------: Load the value name to be deleted.
001230*
001240	   MOVE P-VALUENAME TO INI-FILE-VALUENAME.
001250*
001260* ------------------------: Call the API to update the file.
001270*
001280	   SET API-WRITEPRIVATEPROFILESTRING TO TRUE.
001290	   PERFORM 0106-CALL-WINAPI.
001300*
001310* ------------------------: Update the panel.
001320*
001330	   MOVE SPACE TO P-VALUENAME
001340			 P-DATA.
001350* -====-
001360 0105-INI-FILE-DELETE-SECTION.
001370* ------------------------: Delete the entire [Section]
001380*
001390	   MOVE LOW-VALUE TO INI-FILE-VALUENAME
001400			     INI-FILE-DATA.
001410*
001420* ------------------------: Call the API to delete the [Section].
001430*
001440	   SET API-WRITEPRIVATEPROFILESTRING TO TRUE.
001450	   PERFORM 0106-CALL-WINAPI.
001460*
001470* ------------------------: Update the panel.
001480*
001490	   MOVE SPACE TO P-VALUENAME
001500			 P-DATA.
001510* -====-
001520 0106-CALL-WINAPI.
001530*
001540	   CALL 'GSWINAPI' USING WIN32API-PARMS
001550				 INI-FILE-PARMS
001560				 INI-FILE-FILENAME
001570				 WIN32API-C
001580				 WIN32API-D
001590				 WIN32API-E
001600				 WIN32API-F.
001610*
001620* ------------------------: If function failed,
001630* 			:   load error message into the
001640* 			:   panel's status bar.
001650*
001660	   IF WIN32API-FAILED
001670	     SET AINIPAN-MESSAGE-BAR-BEEP TO TRUE
001680	     MOVE WIN32API-ERROR-TEXT TO AINIPAN-MESSAGE-TEXT
001690	   ELSE
001700	     SET AINIPAN-MESSAGE-BAR-SILENT TO TRUE
001710	     MOVE 'Success!' TO AINIPAN-MESSAGE-TEXT.
